/*
Original script by Nevitro
Major bugfixes and commenting by h3xperiment
*/


using System;
using System.Drawing;
using System.Windows.Forms;
using GTA;

namespace SilientShoot
{

   public class SilientShoot : Script
   {
       bool stopclearwanted=true;
       int indexplayer;
       Weapon yourweapon;

       public SilientShoot()
       {
           //Interval = Settings.GetValueInteger("INTERVAL", "SETTINGS", 5);   // Interval how many times in miliseconds will run script
           this.Tick += new EventHandler(this.IgnoreShoot);
       }
       private void IgnoreShoot(object sender, EventArgs e)
       {
           if (Player.Character.Weapons.CurrentType == Weapon.Handgun_DesertEagle)   // _TAG
           {
               indexplayer = Player.Index;
               if (GTA.Game.isGameKeyPressed(GameKey.Attack)) //GameKey is pressed
               {

                   Ped[] pedArray = GTA.World.GetPeds(Player.Character.Position, 100.00F); //Defines pedArray as all peds within 100F radius of player
                   foreach (GTA.Ped pedignoreplayer in pedArray) //defines pedignoreplayer as the current iteration in pedArray
                   {
                       if ((pedignoreplayer == null) || (pedignoreplayer == Player.Character))
                       {
                           continue;
                       }
                       GTA.Native.Function.Call("SET_EVERYONE_IGNORE_PLAYER", indexplayer, true);
                       GTA.Native.Function.Call("SET_BLOCKING_OF_NON_TEMPORARY_EVENTS", pedignoreplayer, true);
                       GTA.Native.Function.Call("CANCEL_CURRENTLY_PLAYING_AMBIENT_SPEECH", pedignoreplayer);
					   //all peds in pedArray are now ignoring Player
					
                       if (GTA.Native.Function.Call<bool>("IS_CHAR_SHOOTING", Player.Character)) //Player is shooting
                       {
                           stopclearwanted = false;
                       }
                       else
                           if (!(GTA.Native.Function.Call<bool>("IS_CHAR_SHOOTING", Player.Character))) //Player is not shooting
                           {
                               if (pedignoreplayer.Position.DistanceTo(Player.Character.Position) < 15.0F)  //If pedignoreplayer is within a radius of 5.9F they will not ignore player
                               {
                                   GTA.Native.Function.Call("SET_EVERYONE_IGNORE_PLAYER", indexplayer, false);
                                   GTA.Native.Function.Call("SET_BLOCKING_OF_NON_TEMPORARY_EVENTS", pedignoreplayer, false);
                               }
                           }
                   }
               }
               else if (!(GTA.Game.isGameKeyPressed(GameKey.Attack))) //GameKey is not pressed
               {

                   if (stopclearwanted == false) //after player has shot stopclearwanted will be false
                   {
                       stopclearwanted = true;

                       Ped[] pedArray2 = GTA.World.GetPeds(Player.Character.Position, 100.00F);
                       foreach (GTA.Ped pedaround in pedArray2)
                       {
                           if ((pedaround == null) || (pedaround == Player.Character))
                           {
                               continue;
                           }
                           if (pedaround.Position.DistanceTo(Player.Character.Position) < 5.0F)
                           {
                               GTA.Native.Function.Call("SET_EVERYONE_IGNORE_PLAYER", indexplayer, false);
                               GTA.Native.Function.Call("SET_BLOCKING_OF_NON_TEMPORARY_EVENTS", pedaround, false);
                               pedaround.Task.ClearAll();

                           }

                       }
                   }
               }
			   Ped[] pedArray3 = GTA.World.GetPeds(Player.Character.Position, 100.00F); //h3xperiment
                       foreach (GTA.Ped alertped in pedArray3)
                       {
					      if (Player.WantedLevel >= 1)
							{
								GTA.Native.Function.Call("SET_EVERYONE_IGNORE_PLAYER", indexplayer, false);
								GTA.Native.Function.Call("SET_BLOCKING_OF_NON_TEMPORARY_EVENTS", alertped, false);
							}
						}
           }
               else
               {
                   Ped[] pedArray4 = GTA.World.GetPeds(Player.Character.Position, 100.00F);
                   foreach (GTA.Ped pednormal in pedArray4)
                   {
                       if ((pednormal == null) || (pednormal == Player.Character))
                       {
                           continue;
                       }
                       GTA.Native.Function.Call("SET_EVERYONE_IGNORE_PLAYER", indexplayer, false);
                       GTA.Native.Function.Call("SET_BLOCKING_OF_NON_TEMPORARY_EVENTS", pednormal, false);

                   }
               }
           }
       }
}